public class PackageHolder 
        extends Positioned {
        
    private int[] m_packageIds=new int[0];
    private int[] m_packageDestX=new int[0];
    private int[] m_packageDestY=new int[0];
    private int[] m_packageWeight=new int[0];

    public PackageHolder(int x, int y) {
        super(x,y);
    }
    
    public void removePackage(int packageId) {
        int pos=packageArrayPosition(packageId);
        if (pos!=-1) {
            int[] newPackageIds=new int[m_packageIds.length-1];
            int[] newPackageDestX=new int[m_packageIds.length-1];
            int[] newPackageDestY=new int[m_packageIds.length-1];
            int[] newPackageWeight=new int[m_packageIds.length-1];
            int n=0;
            for (int i=0; i<m_packageIds.length; i++) {
                if (m_packageIds[i]!=packageId) {
                    newPackageIds[n]=m_packageIds[i];
                    newPackageDestX[n]=m_packageDestX[i];
                    newPackageDestY[n]=m_packageDestY[i];
                    newPackageWeight[n++]=m_packageWeight[i];
                }
            }
            m_packageIds=newPackageIds;
            m_packageDestX=newPackageDestX;
            m_packageDestY=newPackageDestY;
            m_packageWeight=newPackageWeight;
        }
    }
    
    public boolean hasPackage(int packageId) {
        return (packageArrayPosition(packageId)!=-1);
    }
    
    private int packageArrayPosition(int packageId) {
        for (int i=0; i<m_packageIds.length; i++) {
            if (m_packageIds[i]==packageId) return i;
        }
        return -1;
    }
    
    public void putPackage(int packageId, int destX, int destY, int weight) {
        int pos=packageArrayPosition(packageId);
        if (pos!=-1) {
            m_packageDestX[pos]=destX;
            m_packageDestY[pos]=destY;
            m_packageWeight[pos]=weight;
        } else {
            int[] newPackageIds=new int[m_packageIds.length+1];
            int[] newPackageDestX=new int[m_packageIds.length+1];
            int[] newPackageDestY=new int[m_packageIds.length+1];
            int[] newPackageWeight=new int[m_packageIds.length+1];
            for (int i=0; i<m_packageIds.length; i++) {
                newPackageIds[i]=m_packageIds[i];
                newPackageDestX[i]=m_packageDestX[i];
                newPackageDestY[i]=m_packageDestY[i];
                newPackageWeight[i]=m_packageWeight[i];
            }
            newPackageIds[m_packageIds.length]=packageId;
            newPackageDestX[m_packageIds.length]=destX;
            newPackageDestY[m_packageIds.length]=destY;
            newPackageWeight[m_packageIds.length]=weight;
            m_packageIds=newPackageIds;
            m_packageDestX=newPackageDestX;
            m_packageDestY=newPackageDestY;
            m_packageWeight=newPackageWeight;
        }
    }
    
    public int getKnownPackageWeight() {
        int w=0;
        for (int i=0; i<m_packageIds.length; i++) {
            int weight=m_packageWeight[i];
            if (weight!=-1) {
                w+=weight;
            }
        }
        return w;
    }
    
    public int[] getPackageIds() {
        return m_packageIds;
    }
    
    public int getPackageDestX(int packageId) {
        int pos=packageArrayPosition(packageId);
        if (pos!=-1) {
            return m_packageDestX[pos];
        } else {
            return -1;
        }
    }
    
    public int getPackageDestY(int packageId) {
        int pos=packageArrayPosition(packageId);
        if (pos!=-1) {
            return m_packageDestY[pos];
        } else {
            return -1;
        }
    }
    
    public int getPackageWeight(int packageId) {
        int pos=packageArrayPosition(packageId);
        if (pos!=-1) {
            return m_packageWeight[pos];
        } else {
            return -1;
        }
    }

}